#include <err.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>

int main(int argc, char *argv[])
{
  unsigned char buf[8] = { 0xbf, 0, 0, 0, 0, 0, 0, 0 }, bmask;
  int m, button_press = 0;
  unsigned long r;
  char c, *f = "/var/run/mfifo";

  while((c = getopt(argc,argv,"bp:")) != -1)
    switch(c) {
    case 'b':
	button_press++;
	break;
    case 'p':
	f = optarg;
	break;
    }

  if ((m = open(f, O_WRONLY)) < 0)
    err(1, "cannot open %s", f);

#define dx buf[5]
#define dy buf[6]
#define dz buf[7]
  
  for(;;) {
    r = (unsigned long) random();	/* here we have 32 bit of randomness */
    dx = (unsigned char) ((r & 0xff) % 32 - 16); /* use 5 bits, waste 3	bits */
    r = r >> 8;
    dy = (unsigned char) ((r & 0xff) % 32 - 16); /* again */
    r = r >> 8;
    dz = (unsigned char) ((r & 0xff) % 32 - 16); /* once more */
    r = r >> 8;
    if (button_press && r % 8 == 0) { /* now r<256, a chance is 1/32 */
      r = r >> 3;		/* waste 3 more bits, now r<32 */
      bmask = 1 << (r % 3);	/* choose button to alter */
      /* now release the button if it's pressed or press if it's released */
      buf[1] = (buf[1] & ~bmask) | (((buf[1] & bmask) ^ bmask) & bmask);
    }
    
    if (write (m, buf, sizeof(buf)) != sizeof(buf))
      err(1, "write");
    usleep(100000);
  }
  return 0;  
}
